#!/usr/bin/python3
#  coding:  utf-8
#
#       copyPasteFolders.py
#
#       fileやfolderをclipboardを使ってcopy, pasteする。
#       Qt以外のappに使う。
#
#   20/05/01    新規作成
#      05/02    PyQt4, PyQt5, PySide, PySide2に対応
#      05/23    GTK+3ベースに戻す（PyQt4のみで動かなかった為）
#


import gi
gi.require_version("Gtk", "3.0")
from gi.repository import Gtk, Gdk

import os
import pyTreeFoam


clipboard = Gtk.Clipboard.get(Gdk.SELECTION_CLIPBOARD)

#
#  copyFolders
#------------
def copyFolders(folders):
    """ folders(fullPath)をsystemのclipboardにコピーする"""

    def paths_to_uris(pathes):
        """ path名をuriに変換して返す。"""
        urls = []
        for path in pathes:
            url = "file://" + os.path.abspath(path)
            urls.append(url)
        return urls

    fileMng = pyTreeFoam.fileManager.split("/")[-1].lower()
    #  "x-special/nautilus-clipboard\n"
    copyText = "x-special/" + fileMng + "-clipboard\n"
    copyText += "copy\n"
    copyText += "\n".join(paths_to_uris(folders)) + "\n"
    clipboard.set_text(copyText, -1)

#
#  pasteFolders
#-------------
def pasteFolders():
    """ systemのclipboardからfoldersを取得して返す。"""
    text = clipboard.wait_for_text()
    lines = text.split("\n")
    if len(lines) < 3:
        return []
    files = []
    for line in lines[2:]:
        if line[:len("file://")] == "file://":
            name = line[len("file://"):]
            files.append(name)
    return files

